function [pos_x, pos_y, pos_z, tn] = euler_solver( g , v0, r0, h, v_w, R_0, rho_air, rho_water, t0)
    
    %CALCULATED INITIAL CONSTANTS
    m_0 = (4/3)*pi* R_0^3 * rho_water;
    A_n = R_0^2 * pi;
    
    %UPDATED CONSTANTS
    tn = t0;
    vn = v0;
    rn = r0;
       
    Re_0 = Re(R_0, vn);
    Re_n = Re_0;
    C_d0 = drag_coefficient_of(Re_n);
    C_d = C_d0;
    
    
    C_0 = - ((1/2) * C_d * rho_air * A_n) / m_0;
    C_n = C_0;
    
    %Lists of intermediate positions
    pos_x = [ r0(1)];
    pos_y = [ r0(2)];
    pos_z = [ r0(3)];   
    
    while rn(3) > 0 
            [tn, vn, rn] = onestep_euler(C_n, g, tn, vn, rn, h, v_w);
            if norm(rn) > 50 
                rn(1) = 0;
                rn(2) = 0;
                rn(3) = -0.01;
            end
            %UPTADINT List of intermediate position
            pos_x = [pos_x, rn(1)];
            pos_y = [pos_y, rn(2)];
            pos_z = [pos_z, rn(3)];
            
            Re_n = Re( R_0, vn);
            C_d =  drag_coefficient_of(Re_n);
            C_n = - ((1/2) * C_d * rho_air * A_n) / m_0;     
    end
end
